Index: /palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4652)
+++ /palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4653)
@@ -28,4 +28,13 @@
 ! -----------------
 ! $Id$
+! RTM version 4.0:
+! - Support full-3D geometry:
+!   * Downward faces can only be default type (temporary PALM limitation)
+!   * rad_angular_discretization = .FALSE. is not supported for full-3D cases
+! - Order faces in surf(l) by column
+! - Remove separate direction indices for urban and land faces
+! - Bugfix: skyvft output
+!
+! 4644 2020-08-22 15:05:46Z pavelkrc
 ! Bugfix: remove invalid reordering of vertical surfaces in RTM
 !
@@ -426,5 +435,5 @@
 
     USE surface_mod,                                                           &
-        ONLY:  ind_pav_green, ind_veg_wall, ind_wat_win,                       &
+        ONLY:  ind_pav_green, ind_veg_wall, ind_wat_win, surf_def_h,           &
                surf_lsm_h, surf_lsm_v, surf_type, surf_usm_h, surf_usm_v,      &
                vertical_surfaces_exist
@@ -711,44 +720,26 @@
     INTEGER(iwp), PARAMETER                        ::  iy = 3                             !< position of j-index in surfl and surf
     INTEGER(iwp), PARAMETER                        ::  ix = 4                             !< position of i-index in surfl and surf
-    INTEGER(iwp), PARAMETER                        ::  im = 5                             !< position of surface m-index in surfl and surf
-    INTEGER(iwp), PARAMETER                        ::  nidx_surf = 5                      !< number of indices in surfl and surf
-
-    INTEGER(iwp), PARAMETER                        ::  nsurf_type = 10                    !< number of surf types incl. phys.(land+urban) & (atm.,sky,boundary) surfaces - 1
-
-    INTEGER(iwp), PARAMETER                        ::  iup_u    = 0                       !< 0 - index of urban upward surface (ground or roof)
-    INTEGER(iwp), PARAMETER                        ::  idown_u  = 1                       !< 1 - index of urban downward surface (overhanging)
-    INTEGER(iwp), PARAMETER                        ::  inorth_u = 2                       !< 2 - index of urban northward facing wall
-    INTEGER(iwp), PARAMETER                        ::  isouth_u = 3                       !< 3 - index of urban southward facing wall
-    INTEGER(iwp), PARAMETER                        ::  ieast_u  = 4                       !< 4 - index of urban eastward facing wall
-    INTEGER(iwp), PARAMETER                        ::  iwest_u  = 5                       !< 5 - index of urban westward facing wall
-
-    INTEGER(iwp), PARAMETER                        ::  iup_l    = 6                       !< 6 - index of land upward surface (ground or roof)
-    INTEGER(iwp), PARAMETER                        ::  inorth_l = 7                       !< 7 - index of land northward facing wall
-    INTEGER(iwp), PARAMETER                        ::  isouth_l = 8                       !< 8 - index of land southward facing wall
-    INTEGER(iwp), PARAMETER                        ::  ieast_l  = 9                       !< 9 - index of land eastward facing wall
-    INTEGER(iwp), PARAMETER                        ::  iwest_l  = 10                      !< 10- index of land westward facing wall
-
-    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  idir = (/0, 0,0, 0,1,-1,0,0, 0,1,-1/)   !< surface normal direction x indices
-    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  jdir = (/0, 0,1,-1,0, 0,0,1,-1,0, 0/)   !< surface normal direction y indices
-    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  kdir = (/1,-1,0, 0,0, 0,1,0, 0,0, 0/)   !< surface normal direction z indices
+    INTEGER(iwp), PARAMETER                        ::  nidx_surf = 4                      !< number of indices in surfl and surf
+
+    INTEGER(iwp), PARAMETER                        ::  nsurf_type = 5                     !< number of surf types = surface directions
+
+    INTEGER(iwp), PARAMETER                        ::  iup    = 0                         !< 0 - index of upward surface (ground or roof)
+    INTEGER(iwp), PARAMETER                        ::  idown  = 1                         !< 1 - index of downward surface (overhanging)
+    INTEGER(iwp), PARAMETER                        ::  inorth = 2                         !< 2 - index of northward facing wall
+    INTEGER(iwp), PARAMETER                        ::  isouth = 3                         !< 3 - index of southward facing wall
+    INTEGER(iwp), PARAMETER                        ::  ieast  = 4                         !< 4 - index of eastward facing wall
+    INTEGER(iwp), PARAMETER                        ::  iwest  = 5                         !< 5 - index of westward facing wall
+
+    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  idir = (/0, 0, 0, 0, 1,-1/)      !< surface normal direction x indices
+    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  jdir = (/0, 0, 1,-1, 0, 0/)      !< surface normal direction y indices
+    INTEGER(iwp), DIMENSION(0:nsurf_type), PARAMETER ::  kdir = (/1,-1, 0, 0, 0, 0/)      !< surface normal direction z indices
     REAL(wp),     DIMENSION(0:nsurf_type)          :: facearea                            !< area of single face in respective
                                                                                           !< direction (will be calc'd)
 
-
-!-- indices and sizes of urban and land surface models
-    INTEGER(iwp)                                   ::  startland        !< start index of block of land and roof surfaces
-    INTEGER(iwp)                                   ::  endland          !< end index of block of land and roof surfaces
-    INTEGER(iwp)                                   ::  nlands           !< number of land and roof surfaces in local processor
-    INTEGER(iwp)                                   ::  startwall        !< start index of block of wall surfaces
-    INTEGER(iwp)                                   ::  endwall          !< end index of block of wall surfaces
-    INTEGER(iwp)                                   ::  nwalls           !< number of wall surfaces in local processor
 
 !-- indices needed for RTM netcdf output subroutines
     INTEGER(iwp), PARAMETER                        :: nd = 5
     CHARACTER(LEN=6), DIMENSION(0:nd-1), PARAMETER :: dirname = (/ '_roof ', '_south', '_north', '_west ', '_east ' /)
-    INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER     :: dirint_u = (/ iup_u, isouth_u, inorth_u, iwest_u, ieast_u /)
-    INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER     :: dirint_l = (/ iup_l, isouth_l, inorth_l, iwest_l, ieast_l /)
-    INTEGER(iwp), DIMENSION(0:nd-1)                :: dirstart
-    INTEGER(iwp), DIMENSION(0:nd-1)                :: dirend
+    INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER     :: dirint = (/ iup, isouth, inorth, iwest, ieast /)
 
 !-- indices and sizes of urban and land surface models
@@ -762,4 +753,6 @@
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE,TARGET ::  surfstart        !< starts of blocks of surfaces for individual processors in array surf (indexed from 1)
                                                                         !< respective block for particular processor is surfstart[iproc+1]+1 : surfstart[iproc+1]+nsurfs[iproc+1]
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE,TARGET ::  surfl_col_start  !< start of surfaces in surfl for each x,y column (local surfaces)
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE,TARGET ::  surfg_col_start  !< start of surfaces in surfl for each x,y column (all surfaces)
 
 !-- block variables needed for calculation of the plant canopy model inside the urban surface model
@@ -786,5 +779,5 @@
     REAL(wp), PARAMETER                            ::  ext_coef = 0.6_wp                  !< extinction coefficient (a.k.a. alpha)
     INTEGER(iwp), PARAMETER                        ::  rad_version_len = 10               !< length of identification string of rad version
-    CHARACTER(rad_version_len), PARAMETER          ::  rad_version = 'RAD v. 3.0'         !< identification of version of binary svf and restart files
+    CHARACTER(rad_version_len), PARAMETER          ::  rad_version = 'RAD v. 4.0'         !< identification of version of binary svf and restart files
     INTEGER(iwp)                                   ::  raytrace_discrete_elevs = 40       !< number of discretization steps for elevation (nadir to zenith)
     INTEGER(iwp)                                   ::  raytrace_discrete_azims = 80       !< number of discretization steps for azimuth (out of 360 degrees)
@@ -879,5 +872,7 @@
 #endif
     REAL(wp)                                       ::  prototype_lad    !< prototype leaf area density for computing effective optical depth
-    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  nzterr, plantt   !< temporary global arrays for raytracing
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  nzterrt          !< temporary global arrays for raytracing
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  nzterrb          !< temporary global arrays for raytracing
+    INTEGER(iwp), DIMENSION(:), ALLOCATABLE        ::  plantt           !< temporary global arrays for raytracing
     INTEGER(iwp)                                   ::  plantt_max
 
@@ -1093,11 +1088,9 @@
            cos_zenith, calc_zenith, sun_direction, sun_dir_lat, sun_dir_lon,   &
            idir, jdir, kdir, id, iz, iy, ix,                                   &
-           iup_u, inorth_u, isouth_u, ieast_u, iwest_u,                        &
-           iup_l, inorth_l, isouth_l, ieast_l, iwest_l,                        &
-           nsurf_type, nz_urban_b, nz_urban_t, nz_urban, pch, nsurf,                 &
+           iup, inorth, isouth, ieast, iwest,                                  &
+           nsurf_type, nz_urban_b, nz_urban_t, nz_urban, pch, nsurf,           &
            idsvf, ndsvf, idcsf, ndcsf, kdcsf, pct,                             &
-           radiation_interactions, startwall, startland, endland, endwall,     &
-           skyvf, skyvft, radiation_interactions_on, average_radiation,        &
-           rad_sw_in_diff, rad_sw_in_dir
+           radiation_interactions, skyvf, skyvft, radiation_interactions_on,   &
+           average_radiation, rad_sw_in_diff, rad_sw_in_dir
 
 
@@ -5966,9 +5959,9 @@
 !
 !--  Set up thermal radiation from surfaces
-!--  Horizontal walls
      mm = 1
      DO  i = nxl, nxr
         DO  j = nys, nyn
 !
+!--        Horizontal walls
 !--        urban
            DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
@@ -5996,10 +5989,18 @@
               mm = mm + 1
            ENDDO
-        ENDDO
-     ENDDO
-!
-!--  Vertical walls
-     DO  i = nxl, nxr
-        DO  j = nys, nyn
+!
+!--        Downward facing default surfaces
+!--        TODO: Downward-facing surfaces are only available as default surfaces which lack
+!--        temperature and heat balance, therefore they have to be simulated as neutral to
+!--        radiation, that means having sw/lw reflectivity=1, so they neither absorb nor emit
+!--        radiation and they have zero net heat flux.
+           DO  m = surf_def_h(1)%start_index(j,i), surf_def_h(1)%end_index(j,i)
+              surfoutll(mm) = 0.0_wp
+              albedo_surf(mm) = 1.0_wp
+              emiss_surf(mm)  = 0.0_wp
+              mm = mm + 1
+           ENDDO
+!
+!--        Vertical walls
            DO  l = 0, 3
 !
@@ -6400,186 +6401,106 @@
 !--  Transfer radiation arrays required for energy balance to the respective data types
 !    and claculate relevant radiation model-RTM coupling terms
+     mm = 1
+     DO  i = nxl, nxr
+        DO  j = nys, nyn
+!
+!--        Horizontal walls
+!--        urban
+           DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
+              surf_usm_h%rad_sw_in(m)  = surfinsw(mm)
+              surf_usm_h%rad_sw_out(m) = surfoutsw(mm)
+              surf_usm_h%rad_sw_dir(m) = surfinswdir(mm)
+              surf_usm_h%rad_sw_dif(m) = surfinswdif(mm)
+              surf_usm_h%rad_sw_ref(m) = surfinsw(mm) - surfinswdir(mm) -        &
+                                         surfinswdif(mm)
+              surf_usm_h%rad_sw_res(m) = surfins(mm)
+              surf_usm_h%rad_lw_in(m)  = surfinlw(mm)
+              surf_usm_h%rad_lw_out(m) = surfoutlw(mm)
+              surf_usm_h%rad_net(m)    = surfinsw(mm) - surfoutsw(mm) +          &
+                                         surfinlw(mm) - surfoutlw(mm)
+              surf_usm_h%rad_net_l(m)  = surf_usm_h%rad_net(m)
+              surf_usm_h%rad_lw_dif(m) = surfinlwdif(mm)
+              surf_usm_h%rad_lw_ref(m) = surfinlw(mm) - surfinlwdif(mm)
+              surf_usm_h%rad_lw_res(m) = surfinl(mm)
+              mm = mm + 1
+           ENDDO
+!
+!--        land
+           DO  m = surf_lsm_h%start_index(j,i), surf_lsm_h%end_index(j,i)
+              surf_lsm_h%rad_sw_in(m)  = surfinsw(mm)
+              surf_lsm_h%rad_sw_out(m) = surfoutsw(mm)
+              surf_lsm_h%rad_sw_dir(m) = surfinswdir(mm)
+              surf_lsm_h%rad_sw_dif(m) = surfinswdif(mm)
+              surf_lsm_h%rad_sw_ref(m) = surfinsw(mm) - surfinswdir(mm) -        &
+                                            surfinswdif(mm)
+              surf_lsm_h%rad_sw_res(m) = surfins(mm)
+              surf_lsm_h%rad_lw_in(m)  = surfinlw(mm)
+              surf_lsm_h%rad_lw_out(m) = surfoutlw(mm)
+              surf_lsm_h%rad_net(m)    = surfinsw(mm) - surfoutsw(mm) +          &
+                                         surfinlw(mm) - surfoutlw(mm)
+              surf_lsm_h%rad_lw_dif(m) = surfinlwdif(mm)
+              surf_lsm_h%rad_lw_ref(m) = surfinlw(mm) - surfinlwdif(mm)
+              surf_lsm_h%rad_lw_res(m) = surfinl(mm)
+              mm = mm + 1
+           ENDDO
+!
+!--        Downward facing default surfaces
+!--        TODO: Downward-facing surfaces are only available as default surfaces which lack
+!--        temperature and heat balance, therefore they have to be simulated as neutral to
+!--        radiation, that means having sw/lw reflectivity=1, so they neither absorb nor emit
+!--        radiation and they have zero net heat flux.
+           DO  m = surf_def_h(1)%start_index(j,i), surf_def_h(1)%end_index(j,i)
+              mm = mm + 1
+           ENDDO
+!
+!--        Vertical walls
+           DO  l = 0, 3
+!
+!--           urban
+              DO  m = surf_usm_v(l)%start_index(j,i),                       &
+                      surf_usm_v(l)%end_index(j,i)
+                 surf_usm_v(l)%rad_sw_in(m)  = surfinsw(mm)
+                 surf_usm_v(l)%rad_sw_out(m) = surfoutsw(mm)
+                 surf_usm_v(l)%rad_sw_dir(m) = surfinswdir(mm)
+                 surf_usm_v(l)%rad_sw_dif(m) = surfinswdif(mm)
+                 surf_usm_v(l)%rad_sw_ref(m) = surfinsw(mm) - surfinswdir(mm) -     &
+                                               surfinswdif(mm)
+                 surf_usm_v(l)%rad_sw_res(m) = surfins(mm)
+                 surf_usm_v(l)%rad_lw_in(m)  = surfinlw(mm)
+                 surf_usm_v(l)%rad_lw_out(m) = surfoutlw(mm)
+                 surf_usm_v(l)%rad_net(m)    = surfinsw(mm) - surfoutsw(mm) +       &
+                                               surfinlw(mm) - surfoutlw(mm)
+                 surf_usm_v(l)%rad_net_l(m)  = surf_usm_v(l)%rad_net(m)
+                 surf_usm_v(l)%rad_lw_dif(m) = surfinlwdif(mm)
+                 surf_usm_v(l)%rad_lw_ref(m) = surfinlw(mm) - surfinlwdif(mm)
+                 surf_usm_v(l)%rad_lw_res(m) = surfinl(mm)
+                 mm = mm + 1
+              ENDDO
+!
+!--           land
+              DO  m = surf_lsm_v(l)%start_index(j,i),                       &
+                      surf_lsm_v(l)%end_index(j,i)
+                 surf_lsm_v(l)%rad_sw_in(m)  = surfinsw(mm)
+                 surf_lsm_v(l)%rad_sw_out(m) = surfoutsw(mm)
+                 surf_lsm_v(l)%rad_sw_dir(m) = surfinswdir(mm)
+                 surf_lsm_v(l)%rad_sw_dif(m) = surfinswdif(mm)
+                 surf_lsm_v(l)%rad_sw_ref(m) = surfinsw(mm) - surfinswdir(mm) -     &
+                                               surfinswdif(mm)
+                 surf_lsm_v(l)%rad_sw_res(m) = surfins(mm)
+                 surf_lsm_v(l)%rad_lw_in(m)  = surfinlw(mm)
+                 surf_lsm_v(l)%rad_lw_out(m) = surfoutlw(mm)
+                 surf_lsm_v(l)%rad_net(m)    = surfinsw(mm) - surfoutsw(mm) +       &
+                                               surfinlw(mm) - surfoutlw(mm)
+                 surf_lsm_v(l)%rad_lw_dif(m) = surfinlwdif(mm)
+                 surf_lsm_v(l)%rad_lw_ref(m) = surfinlw(mm) - surfinlwdif(mm)
+                 surf_lsm_v(l)%rad_lw_res(m) = surfinl(mm)
+                 mm = mm + 1
+              ENDDO
+           ENDDO
+        ENDDO
+     ENDDO
 
      DO  i = 1, nsurfl
-        m  = surfl(im,i)
         d  = surfl(id, i)
-!
-!--     (1) Urban surfaces
-!--     upward-facing
-        IF ( surfl(1,i) == iup_u )  THEN
-           surf_usm_h%rad_sw_in(m)  = surfinsw(i)
-           surf_usm_h%rad_sw_out(m) = surfoutsw(i)
-           surf_usm_h%rad_sw_dir(m) = surfinswdir(i)
-           surf_usm_h%rad_sw_dif(m) = surfinswdif(i)
-           surf_usm_h%rad_sw_ref(m) = surfinsw(i) - surfinswdir(i) -        &
-                                      surfinswdif(i)
-           surf_usm_h%rad_sw_res(m) = surfins(i)
-           surf_usm_h%rad_lw_in(m)  = surfinlw(i)
-           surf_usm_h%rad_lw_out(m) = surfoutlw(i)
-           surf_usm_h%rad_net(m)    = surfinsw(i) - surfoutsw(i) +          &
-                                      surfinlw(i) - surfoutlw(i)
-           surf_usm_h%rad_net_l(m)  = surf_usm_h%rad_net(m)
-           surf_usm_h%rad_lw_dif(m) = surfinlwdif(i)
-           surf_usm_h%rad_lw_ref(m) = surfinlw(i) - surfinlwdif(i)
-           surf_usm_h%rad_lw_res(m) = surfinl(i)
-!
-!--     northward-facding
-        ELSEIF ( surfl(1,i) == inorth_u )  THEN
-           surf_usm_v(0)%rad_sw_in(m)  = surfinsw(i)
-           surf_usm_v(0)%rad_sw_out(m) = surfoutsw(i)
-           surf_usm_v(0)%rad_sw_dir(m) = surfinswdir(i)
-           surf_usm_v(0)%rad_sw_dif(m) = surfinswdif(i)
-           surf_usm_v(0)%rad_sw_ref(m) = surfinsw(i) - surfinswdir(i) -     &
-                                         surfinswdif(i)
-           surf_usm_v(0)%rad_sw_res(m) = surfins(i)
-           surf_usm_v(0)%rad_lw_in(m)  = surfinlw(i)
-           surf_usm_v(0)%rad_lw_out(m) = surfoutlw(i)
-           surf_usm_v(0)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
-                                         surfinlw(i) - surfoutlw(i)
-           surf_usm_v(0)%rad_net_l(m)  = surf_usm_v(0)%rad_net(m)
-           surf_usm_v(0)%rad_lw_dif(m) = surfinlwdif(i)
-           surf_usm_v(0)%rad_lw_ref(m) = surfinlw(i) - surfinlwdif(i)
-           surf_usm_v(0)%rad_lw_res(m) = surfinl(i)
-!
-!--     southward-facding
-        ELSEIF ( surfl(1,i) == isouth_u )  THEN
-           surf_usm_v(1)%rad_sw_in(m)  = surfinsw(i)
-           surf_usm_v(1)%rad_sw_out(m) = surfoutsw(i)
-           surf_usm_v(1)%rad_sw_dir(m) = surfinswdir(i)
-           surf_usm_v(1)%rad_sw_dif(m) = surfinswdif(i)
-           surf_usm_v(1)%rad_sw_ref(m) = surfinsw(i) - surfinswdir(i) -     &
-                                         surfinswdif(i)
-           surf_usm_v(1)%rad_sw_res(m) = surfins(i)
-           surf_usm_v(1)%rad_lw_in(m)  = surfinlw(i)
-           surf_usm_v(1)%rad_lw_out(m) = surfoutlw(i)
-           surf_usm_v(1)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
-                                         surfinlw(i) - surfoutlw(i)
-           surf_usm_v(1)%rad_net_l(m)  = surf_usm_v(1)%rad_net(m)
-           surf_usm_v(1)%rad_lw_dif(m) = surfinlwdif(i)
-           surf_usm_v(1)%rad_lw_ref(m) = surfinlw(i) - surfinlwdif(i)
-           surf_usm_v(1)%rad_lw_res(m) = surfinl(i)
-!
-!--     eastward-facing
-        ELSEIF ( surfl(1,i) == ieast_u )  THEN
-           surf_usm_v(2)%rad_sw_in(m)  = surfinsw(i)
-           surf_usm_v(2)%rad_sw_out(m) = surfoutsw(i)
-           surf_usm_v(2)%rad_sw_dir(m) = surfinswdir(i)
-           surf_usm_v(2)%rad_sw_dif(m) = surfinswdif(i)
-           surf_usm_v(2)%rad_sw_ref(m) = surfinsw(i) - surfinswdir(i) -     &
-                                         surfinswdif(i)
-           surf_usm_v(2)%rad_sw_res(m) = surfins(i)
-           surf_usm_v(2)%rad_lw_in(m)  = surfinlw(i)
-           surf_usm_v(2)%rad_lw_out(m) = surfoutlw(i)
-           surf_usm_v(2)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
-                                         surfinlw(i) - surfoutlw(i)
-           surf_usm_v(2)%rad_net_l(m)  = surf_usm_v(2)%rad_net(m)
-           surf_usm_v(2)%rad_lw_dif(m) = surfinlwdif(i)
-           surf_usm_v(2)%rad_lw_ref(m) = surfinlw(i) - surfinlwdif(i)
-           surf_usm_v(2)%rad_lw_res(m) = surfinl(i)
-!
-!--     westward-facding
-        ELSEIF ( surfl(1,i) == iwest_u )  THEN
-           surf_usm_v(3)%rad_sw_in(m)  = surfinsw(i)
-           surf_usm_v(3)%rad_sw_out(m) = surfoutsw(i)
-           surf_usm_v(3)%rad_sw_dir(m) = surfinswdir(i)
-           surf_usm_v(3)%rad_sw_dif(m) = surfinswdif(i)
-           surf_usm_v(3)%rad_sw_ref(m) = surfinsw(i) - surfinswdir(i) -     &
-                                         surfinswdif(i)
-           surf_usm_v(3)%rad_sw_res(m) = surfins(i)
-           surf_usm_v(3)%rad_lw_in(m)  = surfinlw(i)
-           surf_usm_v(3)%rad_lw_out(m) = surfoutlw(i)
-           surf_usm_v(3)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
-                                         surfinlw(i) - surfoutlw(i)
-           surf_usm_v(3)%rad_net_l(m)  = surf_usm_v(3)%rad_net(m)
-           surf_usm_v(3)%rad_lw_dif(m) = surfinlwdif(i)
-           surf_usm_v(3)%rad_lw_ref(m) = surfinlw(i) - surfinlwdif(i)
-           surf_usm_v(3)%rad_lw_res(m) = surfinl(i)
-!
-!--     (2) land surfaces
-!--     upward-facing
-        ELSEIF ( surfl(1,i) == iup_l )  THEN
-           surf_lsm_h%rad_sw_in(m)  = surfinsw(i)
-           surf_lsm_h%rad_sw_out(m) = surfoutsw(i)
-           surf_lsm_h%rad_sw_dir(m) = surfinswdir(i)
-           surf_lsm_h%rad_sw_dif(m) = surfinswdif(i)
-           surf_lsm_h%rad_sw_ref(m) = surfinsw(i) - surfinswdir(i) -        &
-                                         surfinswdif(i)
-           surf_lsm_h%rad_sw_res(m) = surfins(i)
-           surf_lsm_h%rad_lw_in(m)  = surfinlw(i)
-           surf_lsm_h%rad_lw_out(m) = surfoutlw(i)
-           surf_lsm_h%rad_net(m)    = surfinsw(i) - surfoutsw(i) +          &
-                                      surfinlw(i) - surfoutlw(i)
-           surf_lsm_h%rad_lw_dif(m) = surfinlwdif(i)
-           surf_lsm_h%rad_lw_ref(m) = surfinlw(i) - surfinlwdif(i)
-           surf_lsm_h%rad_lw_res(m) = surfinl(i)
-!
-!--     northward-facding
-        ELSEIF ( surfl(1,i) == inorth_l )  THEN
-           surf_lsm_v(0)%rad_sw_in(m)  = surfinsw(i)
-           surf_lsm_v(0)%rad_sw_out(m) = surfoutsw(i)
-           surf_lsm_v(0)%rad_sw_dir(m) = surfinswdir(i)
-           surf_lsm_v(0)%rad_sw_dif(m) = surfinswdif(i)
-           surf_lsm_v(0)%rad_sw_ref(m) = surfinsw(i) - surfinswdir(i) -     &
-                                         surfinswdif(i)
-           surf_lsm_v(0)%rad_sw_res(m) = surfins(i)
-           surf_lsm_v(0)%rad_lw_in(m)  = surfinlw(i)
-           surf_lsm_v(0)%rad_lw_out(m) = surfoutlw(i)
-           surf_lsm_v(0)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
-                                         surfinlw(i) - surfoutlw(i)
-           surf_lsm_v(0)%rad_lw_dif(m) = surfinlwdif(i)
-           surf_lsm_v(0)%rad_lw_ref(m) = surfinlw(i) - surfinlwdif(i)
-           surf_lsm_v(0)%rad_lw_res(m) = surfinl(i)
-!
-!--     southward-facding
-        ELSEIF ( surfl(1,i) == isouth_l )  THEN
-           surf_lsm_v(1)%rad_sw_in(m)  = surfinsw(i)
-           surf_lsm_v(1)%rad_sw_out(m) = surfoutsw(i)
-           surf_lsm_v(1)%rad_sw_dir(m) = surfinswdir(i)
-           surf_lsm_v(1)%rad_sw_dif(m) = surfinswdif(i)
-           surf_lsm_v(1)%rad_sw_ref(m) = surfinsw(i) - surfinswdir(i) -     &
-                                         surfinswdif(i)
-           surf_lsm_v(1)%rad_sw_res(m) = surfins(i)
-           surf_lsm_v(1)%rad_lw_in(m)  = surfinlw(i)
-           surf_lsm_v(1)%rad_lw_out(m) = surfoutlw(i)
-           surf_lsm_v(1)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
-                                         surfinlw(i) - surfoutlw(i)
-           surf_lsm_v(1)%rad_lw_dif(m) = surfinlwdif(i)
-           surf_lsm_v(1)%rad_lw_ref(m) = surfinlw(i) - surfinlwdif(i)
-           surf_lsm_v(1)%rad_lw_res(m) = surfinl(i)
-!
-!--     eastward-facing
-        ELSEIF ( surfl(1,i) == ieast_l )  THEN
-           surf_lsm_v(2)%rad_sw_in(m)  = surfinsw(i)
-           surf_lsm_v(2)%rad_sw_out(m) = surfoutsw(i)
-           surf_lsm_v(2)%rad_sw_dir(m) = surfinswdir(i)
-           surf_lsm_v(2)%rad_sw_dif(m) = surfinswdif(i)
-           surf_lsm_v(2)%rad_sw_ref(m) = surfinsw(i) - surfinswdir(i) -     &
-                                         surfinswdif(i)
-           surf_lsm_v(2)%rad_sw_res(m) = surfins(i)
-           surf_lsm_v(2)%rad_lw_in(m)  = surfinlw(i)
-           surf_lsm_v(2)%rad_lw_out(m) = surfoutlw(i)
-           surf_lsm_v(2)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
-                                         surfinlw(i) - surfoutlw(i)
-           surf_lsm_v(2)%rad_lw_dif(m) = surfinlwdif(i)
-           surf_lsm_v(2)%rad_lw_ref(m) = surfinlw(i) - surfinlwdif(i)
-           surf_lsm_v(2)%rad_lw_res(m) = surfinl(i)
-!
-!--     westward-facing
-        ELSEIF ( surfl(1,i) == iwest_l )  THEN
-           surf_lsm_v(3)%rad_sw_in(m)  = surfinsw(i)
-           surf_lsm_v(3)%rad_sw_out(m) = surfoutsw(i)
-           surf_lsm_v(3)%rad_sw_dir(m) = surfinswdir(i)
-           surf_lsm_v(3)%rad_sw_dif(m) = surfinswdif(i)
-           surf_lsm_v(3)%rad_sw_ref(m) = surfinsw(i) - surfinswdir(i) -     &
-                                         surfinswdif(i)
-           surf_lsm_v(3)%rad_sw_res(m) = surfins(i)
-           surf_lsm_v(3)%rad_lw_in(m)  = surfinlw(i)
-           surf_lsm_v(3)%rad_lw_out(m) = surfoutlw(i)
-           surf_lsm_v(3)%rad_net(m)    = surfinsw(i) - surfoutsw(i) +       &
-                                         surfinlw(i) - surfoutlw(i)
-           surf_lsm_v(3)%rad_lw_dif(m) = surfinlwdif(i)
-           surf_lsm_v(3)%rad_lw_ref(m) = surfinlw(i) - surfinlwdif(i)
-           surf_lsm_v(3)%rad_lw_res(m) = surfinl(i)
-        ENDIF
 !
 !--     RTM coupling terms
@@ -6942,4 +6863,5 @@
        INTEGER(iwp)        ::  k_topo               !< vertical index indicating
                                                     !< topography top for given (j,i)
+       INTEGER(iwp)        ::  icol                 !< flat column number (in (y,x) fortran order)
        INTEGER(iwp)        ::  isurf, ipcgb, imrt
        INTEGER(iwp)        ::  nzptl, nzubl, nzutl
@@ -6965,5 +6887,5 @@
 !--    for any upward-facing wall (see bit 12).
        nzubl = MINVAL( topo_top_ind(nys:nyn,nxl:nxr,0) )
-       nzutl = MAXVAL( topo_top_ind(nys:nyn,nxl:nxr,0) )
+       nzutl = MAXVAL( topo_top_ind(nys:nyn,nxl:nxr,5) )
 
        nzubl = MAX( nzubl, nzb )
@@ -7077,20 +6999,11 @@
 !--    Number of horizontal surfaces including land- and roof surfaces in both USM and LSM. Note that
 !--    All horizontal surface elements are already counted in surface_mod.
-       startland = 1
-       nsurfl    = surf_usm_h%ns + surf_lsm_h%ns
-       endland   = nsurfl
-       nlands    = endland - startland + 1
-
+       nsurfl    = surf_usm_h%ns + surf_lsm_h%ns + surf_def_h(1)%ns
 !
 !--    Number of vertical surfaces in both USM and LSM. Note that all vertical surface elements are
 !--    already counted in surface_mod.
-       startwall = nsurfl+1
        DO  i = 0,3
           nsurfl = nsurfl + surf_usm_v(i)%ns + surf_lsm_v(i)%ns
        ENDDO
-       endwall = nsurfl
-       nwalls  = endwall - startwall + 1
-       dirstart = (/ startland, startwall, startwall, startwall, startwall /)
-       dirend = (/ endland, endwall, endwall, endwall, endwall /)
 
 !--    fill gridpcbl and pcbl
@@ -7196,15 +7109,22 @@
        ENDIF
 
-!--    add horizontal surface elements (land and urban surfaces)
-!--    TODO: add urban overhanging surfaces (idown_u)
+       ALLOCATE( surfl_col_start(0:nnx*nny-1), surfg_col_start(0:(nx+1)*(ny+1)) )
+!
+!--    Add horizontal and vertical surface elements (land and urban surfaces)
+!--    ordered by x,y column (y most varying)
+!--    TODO: remove the hard coding of l = 0 to l = idirection
+       icol = 0
        DO i = nxl, nxr
            DO j = nys, nyn
+!
+!--           Save column start
+              surfl_col_start(icol) = isurf + 1
+              icol = icol + 1
+!
+!--           Horizontal surfaces
               DO  m = surf_usm_h%start_index(j,i), surf_usm_h%end_index(j,i)
                  k = surf_usm_h%k(m)
                  isurf = isurf + 1
-                 surfl(:,isurf) = (/iup_u,k,j,i,m/)
-                 IF ( rad_angular_discretization ) THEN
-                    gridsurf(iup_u,k,j,i) = isurf
-                 ENDIF
+                 surfl(:,isurf) = (/iup,k,j,i/)
               ENDDO
 
@@ -7212,33 +7132,24 @@
                  k = surf_lsm_h%k(m)
                  isurf = isurf + 1
-                 surfl(:,isurf) = (/iup_l,k,j,i,m/)
-                 IF ( rad_angular_discretization ) THEN
-                    gridsurf(iup_u,k,j,i) = isurf
-                 ENDIF
+                 surfl(:,isurf) = (/iup,k,j,i/)
               ENDDO
 
-           ENDDO
-       ENDDO
-
-!--    add vertical surface elements (land and urban surfaces)
-!--    TODO: remove the hard coding of l = 0 to l = idirection
-       DO i = nxl, nxr
-           DO j = nys, nyn
+              DO  m = surf_def_h(1)%start_index(j,i), surf_def_h(1)%end_index(j,i)
+                 k = surf_def_h(1)%k(m)
+                 isurf = isurf + 1
+                 surfl(:,isurf) = (/idown,k,j,i/)
+              ENDDO
+!
+!--           Vertical surfaces
               l = 0
               DO  m = surf_usm_v(l)%start_index(j,i), surf_usm_v(l)%end_index(j,i)
                  k = surf_usm_v(l)%k(m)
                  isurf = isurf + 1
-                 surfl(:,isurf) = (/inorth_u,k,j,i,m/)
-                 IF ( rad_angular_discretization ) THEN
-                    gridsurf(inorth_u,k,j,i) = isurf
-                 ENDIF
+                 surfl(:,isurf) = (/inorth,k,j,i/)
               ENDDO
               DO  m = surf_lsm_v(l)%start_index(j,i), surf_lsm_v(l)%end_index(j,i)
                  k = surf_lsm_v(l)%k(m)
                  isurf = isurf + 1
-                 surfl(:,isurf) = (/inorth_l,k,j,i,m/)
-                 IF ( rad_angular_discretization ) THEN
-                    gridsurf(inorth_u,k,j,i) = isurf
-                 ENDIF
+                 surfl(:,isurf) = (/inorth,k,j,i/)
               ENDDO
 
@@ -7247,16 +7158,10 @@
                  k = surf_usm_v(l)%k(m)
                  isurf = isurf + 1
-                 surfl(:,isurf) = (/isouth_u,k,j,i,m/)
-                 IF ( rad_angular_discretization ) THEN
-                    gridsurf(isouth_u,k,j,i) = isurf
-                 ENDIF
+                 surfl(:,isurf) = (/isouth,k,j,i/)
               ENDDO
               DO  m = surf_lsm_v(l)%start_index(j,i), surf_lsm_v(l)%end_index(j,i)
                  k = surf_lsm_v(l)%k(m)
                  isurf = isurf + 1
-                 surfl(:,isurf) = (/isouth_l,k,j,i,m/)
-                 IF ( rad_angular_discretization ) THEN
-                    gridsurf(isouth_u,k,j,i) = isurf
-                 ENDIF
+                 surfl(:,isurf) = (/isouth,k,j,i/)
               ENDDO
 
